=== debian/changelog ===
libcoap3 (4.3.5-1) unstable; urgency=medium

  * Team upload (Closes: #1111914)
  * New upstream release.
    This release contains fixes for:
        CVE-2023-51847, CVE-2024-46304, CVE-2024-31031
        CVE-2024-0962
    (Closes: #1084981)
    (Closes: #1070362)
    (Closes: #1061704)
  * debian/control: add myself to Uploader:
                    thanks Carsten for taking care of this
                    package all the years
                    (Closes: #1062655)
  * debian/contol: bump standard to 4.7.2 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 25 Aug 2025 19:23:22 +0200
