=== debian/control ===
Source: libcoap3
Section: libs
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders:
 Thorsten Alteholz <debian@alteholz.de>,
Build-Depends: dpkg-dev (>= 1.22.5),
 asciidoc-base,
 debhelper-compat (= 13),
 doxygen,
 exuberant-ctags,
 graphviz,
 libgnutls28-dev,
 libssl-dev,
 pkgconf,
 xmlto,
Standards-Version: 4.7.2
Rules-Requires-Root: binary-targets
Homepage: https://libcoap.net/
Vcs-Browser: https://salsa.debian.org/debian-iot-team/libcoap3
Vcs-Git: https://salsa.debian.org/debian-iot-team/libcoap3.git

Package: libcoap3t64
Provides: ${t64:Provides}
Replaces: libcoap3
Breaks: libcoap3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libcoap2,
Description: C-Implementation of CoAP - libraries API version 3
 Lightweight application-protocol for devices that are constrained their
 resources such as computing power, RF range, memory, bandwidth, or network
 packet sizes. This protocol, CoAP, is developed in the IETF working group
 "CoRE", <https://datatracker.ietf.org/wg/6lowapp/about/> and was
 standardized in RFC 7252.
 .
 The libcoap library v3 has DTLS functionality included based on TLS
 functions provided by GnuTLS or OpenSSL with enhanced behavior to the
 previous API version.
 .
 This package contains the various libcoap libraries based on API v3 with
 and without DTLS functionality.

Package: libcoap3-bin
Architecture: any
Depends:
 libcoap3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libcoap2-bin,
Description: C-Implementation of CoAP - example binaries API version 3
 The libcoap provides some example binary files to show the usage of a CoAP
 Server, CoAP Client and a Resource Directory implementation. These examples
 heavily rely on the libcoap as the core functionality is based there.
 .
 This package provides the following example binaries without DTLS functions:
  * coap-client-notls
    A command-line client that allows you to interact with CoAP resources.
 .
  * coap-server-notls
    Simple server that can provide CoAP resources for simple testing cases.
 .
  * coap-rd-notls
    This binary let you simulate various CoAP resources mostly for testing
    purpose.
 .
 This package provides the following example binaries with DTLS functions:
  * coap-client-{gnutls,openssl}
    A command-line client that allows you to interact with CoAP resources
    based on TLS functions by GnuTLS or OpenSSL.
 .
  * coap-server-{gnutls,openssl}
    Simple server that can provide CoAP resources for simple testing cases
    based on TLS functions by GnuTLS or OpenSSL.
 .
  * coap-rd-{gnutls,openssl}
    This binary let you simulate various CoAP resources mostly for testing
    based on TLS functions by GnuTLS or OpenSSL.
 .
 You can use these files without any exception no matter as they named
 examples. Please see the respective man pages for usage instructions.

Package: libcoap3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libc6-dev,
 libcoap3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: C-Implementation of CoAP - development files API version 3
 Lightweight application-protocol for devices that are constrained their
 resources such as computing power, RF range, memory, bandwidth, or network
 packet sizes. This protocol, CoAP, is developed in the IETF working group
 "CoRE", <https://datatracker.ietf.org/wg/6lowapp/about/> and was
 standardized in RFC 7252.
 .
 This package contains the developer files like headers, the static library
 and the pkg-config files.

Package: libcoap3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Recommends:
 libcoap3-dev (= ${binary:Version}),
 www-browser,
Description: C-Implementation of CoAP - HTML based documentation files for API v3
 Lightweight application-protocol for devices that are constrained their
 resources such as computing power, RF range, memory, bandwidth, or network
 packet sizes. This protocol, CoAP, is developed in the IETF working group
 "CoRE", <https://datatracker.ietf.org/wg/6lowapp/about/> and was
 standardized in RFC 7252.
 .
 This package contains the Doxygen generated library API HTML documentation
 for libcoap.
 They can be accessed by open /usr/share/doc/libcoap3-doc/html/index.html.
